#compdef makex

# AUTOMATICALLY GENERATED by `shtab`


_shtab_makex_commands() {
  local _commands=(
    "affected:"
    "complete:"
    "completions:Generate completion files for shells."
    "dot:"
    "evaluate:"
    "inputs:"
    "outputs:"
    "path:Get the output path of a task."
    "run:Run a task or list of tasks."
    "targets:"
    "tasks:"
    "version:"
    "workspace:Print the current workspace, or the workspace detected at path."
  )
  _describe 'makex commands' _commands
}

_shtab_makex_options=(
  "(- : *)"{-h,--help}"[show this help message and exit]"
  "*--verbose[Verbosity of makex messaging. Specify multiple times or set to a number between 0 and 3. (The default is 0 and the maximum is 3).]"
  "--debug[Enable debug and logging to the maximum level.]"
  "--color[Print colored messaging.]:color:(off auto on)"
  "--cache[The unified external cache\/build path.]:cache:"
)

_shtab_makex_affected_options=(
  "(- : *)"{-h,--help}"[show this help message and exit]"
  "--threads[Worker threads to spawn for running\/evaluating targets in parallel. Automatically detected.]:threads:"
  "(*):files:"
)

_shtab_makex_complete_options=(
  "(- : *)"{-h,--help}"[show this help message and exit]"
  ":May be a complete\/partial path. May include a target name.:"
)

_shtab_makex_completions_options=(
  "(- : *)"{-h,--help}"[show this help message and exit]"
  "--shell[]:shell:(bash zsh)"
  "--internal[]"
  ":The output file to write the completions to. If not specified, will the completion will be written to standard out.:"
)

_shtab_makex_dot_options=(
  "(- : *)"{-h,--help}"[show this help message and exit]"
  "--files[Include\/evaluate files\/globs. May be slow.]:files:"
  "*--ignore[Specify file ignore patterns for input\/output files.]:ignore:"
  "--threads[Worker threads to spawn for running\/evaluating targets in parallel. Automatically detected.]:threads:"
  "(*):targets:"
)

_shtab_makex_evaluate_options=(
  "(- : *)"{-h,--help}"[show this help message and exit]"
  ":file_or_directory:"
  ":Name of the variable to evaluate. Can be target(name).\* to evaluated variables of named targets  in the file.:"
)

_shtab_makex_inputs_options=(
  "(- : *)"{-h,--help}"[show this help message and exit]"
  "*--ignore[Specify file ignore patterns.]:ignore:"
  "--threads[Worker threads to spawn for running\/evaluating targets in parallel. Automatically detected.]:threads:"
  "(*):targets:"
)

_shtab_makex_outputs_options=(
  "(- : *)"{-h,--help}"[show this help message and exit]"
  "*--ignore[Specify file ignore patterns.]:ignore:"
  "--threads[Worker threads to spawn for running\/evaluating targets in parallel. Automatically detected.]:threads:"
  "(*):output_names:"
)

_shtab_makex_path_options=(
  "(- : *)"{-h,--help}"[show this help message and exit]"
  "--real[Return cache path. This may be slower as it must resolve Workspaces.]"
  ":Name and optional path of a task. \/\/path\:name, \/\/\:name, \:name are all valid.:"
)

_shtab_makex_run_options=(
  "(- : *)"{-h,--help}"[show this help message and exit]"
  "--directory[Change to directory before evaluating tasks.]:directory:"
  "--force[Always run all task even if they don\'t need to be.]"
  "--dry[Do a dry run. Nothing will be executed.]"
  "--threads[Worker threads to spawn for running\/evaluating targets in parallel. Automatically detected.]:threads:"
  "(*):tasks:_shtab_makex_complete_target"
)

_shtab_makex_targets_options=(
  "(- : *)"{-h,--help}"[show this help message and exit]"
  "--paths[Path to a makex file or directory]:paths:(absolute workspace relative None)"
  "--prefix[]"
  ":Path to a makex file or directory. The current directory is the default.:"
)

_shtab_makex_tasks_options=(
  "(- : *)"{-h,--help}"[show this help message and exit]"
  "--paths[Path to a makex file or directory]:paths:(absolute workspace relative None)"
  "--prefix[]"
  ":Path to a makex file or directory. The current directory is the default.:"
)

_shtab_makex_version_options=(
  "(- : *)"{-h,--help}"[show this help message and exit]"
)

_shtab_makex_workspace_options=(
  "(- : *)"{-h,--help}"[show this help message and exit]"
  ":Path representing a workspace, or inside a workspace.:"
)


_shtab_makex() {
  local context state line curcontext="$curcontext" one_or_more='(-)*' remainder='(*)'

  if ((${_shtab_makex_options[(I)${(q)one_or_more}*]} + ${_shtab_makex_options[(I)${(q)remainder}*]} == 0)); then  # noqa: E501
    _shtab_makex_options+=(': :_shtab_makex_commands' '*::: :->makex')
  fi
  _arguments -C -s $_shtab_makex_options

  case $state in
    makex)
      words=($line[1] "${words[@]}")
      (( CURRENT += 1 ))
      curcontext="${curcontext%:*:*}:_shtab_makex-$line[1]:"
      case $line[1] in
        affected) _arguments -C -s $_shtab_makex_affected_options ;;
        complete) _arguments -C -s $_shtab_makex_complete_options ;;
        completions) _arguments -C -s $_shtab_makex_completions_options ;;
        dot) _arguments -C -s $_shtab_makex_dot_options ;;
        evaluate) _arguments -C -s $_shtab_makex_evaluate_options ;;
        inputs) _arguments -C -s $_shtab_makex_inputs_options ;;
        outputs) _arguments -C -s $_shtab_makex_outputs_options ;;
        path) _arguments -C -s $_shtab_makex_path_options ;;
        run) _arguments -C -s $_shtab_makex_run_options ;;
        targets) _arguments -C -s $_shtab_makex_targets_options ;;
        tasks) _arguments -C -s $_shtab_makex_tasks_options ;;
        version) _arguments -C -s $_shtab_makex_version_options ;;
        workspace) _arguments -C -s $_shtab_makex_workspace_options ;;
      esac
  esac
}

# Custom Preamble

_shtab_makex_complete_target(){
  local -a plugins
  local lastword=${PREFIX}
  local plugins=($(makex complete "$lastword"))
  #_describe 'targets' plugins
  #_multi_parts -i "\n" plugins
  compadd -a - plugins
  #  -M 'r:|=*'
  #makex complete "$curcontext"
}

# End Custom Preamble


typeset -A opt_args

if [[ $zsh_eval_context[-1] == eval ]]; then
  # eval/source/. command, register function for later
  compdef _shtab_makex -N makex
else
  # autoload from fpath, call function directly
  _shtab_makex "$@"
fi

